#!/bin/sh

# Use this build script if you want to compare TSF to Protobuf.

set -e
set -x

CFLAGS="`tsf_config --cppflags --cflags` -Ibuild -I."
LDFLAGS=`tsf_config --ldflags --libs`

mkdir -p build

tsf_define tsf_ir.t -pthread -odir build
tsf_define tsf_ir_different.t -pthread -odir build

gcc -c -o build/tsf_ir.o build/tsf_ir.c $CFLAGS
gcc -c -o build/tsf_ir_different.o build/tsf_ir_different.c $CFLAGS
gcc -c -o build/tsf_ir_speed.o tsf_ir_speed.c $CFLAGS
gcc -o build/tsf_ir_speed build/tsf_ir.o build/tsf_ir_different.o build/tsf_ir_speed.o $LDFLAGS

CFLAGS="`tsf_config --cppflags --cxxflags` -O2 -g -Wall -Ibuild -I."
LDFLAGS="-lprotobuf `tsf_config --ldflags --libs`"

protoc proto_ir.proto --cpp_out=build
g++ -c -o build/proto_ir.pb.o build/proto_ir.pb.cc $CFLAGS
g++ -c -o build/proto_ir_speed.o proto_ir_speed.cpp $CFLAGS
g++ -o build/proto_ir_speed build/proto_ir.pb.o build/proto_ir_speed.o $LDFLAGS
