declare DOperand: int16 // negative means a global reference, non-negative means a local reference
declare DType: string
declare DCodeOffset: int16

declare DVariableDecl: struct {
    type: DType
}

declare DInstruction: choice {
    nop: void
    
    mov: struct {
        dest: DOperand
        src: DOperand
    }
    
    add: struct {
        dest: DOperand
        src: DOperand
    }
    
    alloc: struct {
        type: DType
    }
    
    ret: struct {
        src: DOperand
    }
    
    jump: struct {
        target: DCodeOffset
    }
    
    call: struct {
        dest: DOperand
        callee: DOperand
        args: array of DOperand
    }
    
    branchZero: struct {
        src: DOperand
        target: DCodeOffset
    }
}

declare DProcedure : struct {
    name: string
}

declare DProcedureDecl: struct {
    pull DProcedure
}

declare DProcedureDefn: struct {
    pull DProcedure
    variables: array of DVariableDecl
    code: array of DInstruction
}

declare DProgramElement: choice {
    procedureDecl: DProcedureDecl
    procedureDefn: DProcedureDefn
}

declare DProgram: struct {
    globals: array of DProgramElement
}

